首页 > 其他分享 >Codeforces Round 642 (Div3)

Codeforces Round 642 (Div3)

时间:2023-04-05 23:45:33浏览次数:62  
标签:std cnt const int Codeforces cin 变为 642 Div3

K-periodic Garland

给定一个长度位\(n\)的\(01\)串,每次操作可以将\(1\)变为\(0\)或者将\(0\)变为\(1\),现在你需要通过操作使得所有\(1\)之间的距离为\(k\),求最少的操作次数,注意全为\(0\)也算

\(1<=n<=1e6,1<=k<=n\)

\(dp\) / 贪心 : 最大子段和思想

方法一:\(dp\) \(O(n)\)

状态表示:\(f[i][0/1]\):代表将区间\([1,i]\)变为合法串的最小操作次数,且第\(i\)位为\(0/1\)

状态转移:

  1. 贪心考虑只有两种情况的时候我们可以将第\(i\)位变成\(1\):
  • 若第\(i-k\)位也是\(1\),我们可以考虑将第\(i\)位变为\(1\),那么我们需要将\([i-k+1,i-1]\)中的所有1变为0
  • 我们同样可以考虑使第\(i\)位前面所有的1变为0,从第\(i\)位的\(1\)重新当作起始位置,那么我们需要将前面所有的1变为0
  • 同时如果该位本身不是\(1\),我们需要将其变为\(1\)

\(f[i][1]=min(f[i][1]+pre[i-1]-pre[i-k],pre[i-1]) + (s[i]=='0')\)

  1. 同样只有两种情况我们可以将第\(i\)位变为\(0\):
  • 第\(i-1\)位是1的情况
  • 第\(i-1\)位是0的情况
  • 如果第\(i\)位不是0,我们需要将其变为0

\(f[i][0]=min(f[i-1][1],f[i-1][0])+(s[i]=='1')\)

状态初始:\(f[i]=0\)

方法二:贪心 + 枚举对\(k\)余数 \(复杂度:调和级数O(nlogn)\)

由题意可知这些\(1\)一定是连续的且距离间隔\(k\),这说明1所处的位置对\(k\)取模的模数是相同的,且这些1连续,所以我们可以考虑根据对\(k\)的余数来枚举\(1\)的起始位置,所以我们不妨先将所有的1变为0

我们设\(cnt\):可以减免的答案贡献,或者说从起始位置到现在1的前缀和数量与0的前缀和数量之差;

  1. 对于某一位来说,我们需要其为1,并且其本身已经为1,说明我们原本不用将其变为0,所以这部分答案可以减免,\(cnt\)++,
  2. 对于某一位来说,我们需要其为1,但是其本身为0,说明我们这部分答案不能减免,\(cnt\)--,
  3. 如果\(cnt<0\),说明从起始位置开始0的数量已经比1的数量多了,也就是说我们将这些前面位置都变成1就比全部变为0吃亏,倒不如全部变为0,借用最大子段和的思想我们直接舍弃前面的部分,将该位置重新当成起始位置,\(cnt=0\)
  4. 我们在枚举过程中始终维护\(cnt\)的最大值即可

时间复杂度为调和级数:\(O(nlogn)\)

#include <bits/stdc++.h>
#define Zeoy std::ios::sync_with_stdio(false), std::cin.tie(0), std::cout.tie(0)
#define debug(x) cerr << #x << '=' << x << endl
#define all(x) (x).begin(), (x).end()
#define rson id << 1 | 1
#define lson id << 1
#define int long long
#define mpk make_pair
#define endl '\n'
using namespace std;
typedef unsigned long long ULL;
typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
const int inf = 0x3f3f3f3f;
const ll INF = 0x3f3f3f3f3f3f3f3f;
const int mod = 1e9 + 7;
const double eps = 1e-9;
const int N = 1e6 + 10, M = 4e5 + 10;

int n, k;
int f[N][2];
int pre[N];

void solve()
{
    cin >> n >> k;
    string s;
    cin >> s;
    s = " " + s;
    for (int i = 1; i <= n; ++i)
        pre[i] = pre[i - 1] + (s[i] == '1');
    for (int i = 1; i <= n; ++i)
    {
        f[i][1] = min(f[max(0ll, i - k)][1] + pre[i - 1] - pre[max(0ll, i - k)], pre[i - 1]) + (s[i] == '0');
        f[i][0] = min(f[i - 1][1], f[i - 1][0]) + (s[i] == '1');
    }
    cout << min(f[n][0], f[n][1]) << endl;
}
signed main(void)
{
    Zeoy;
    int T = 1;
    cin >> T;
    while (T--)
    {
        solve();
    }
    return 0;
}
#include <bits/stdc++.h>
#define Zeoy std::ios::sync_with_stdio(false), std::cin.tie(0), std::cout.tie(0)
#define debug(x) cerr << #x << '=' << x << endl
#define all(x) (x).begin(), (x).end()
#define rson id << 1 | 1
#define lson id << 1
#define int long long
#define mpk make_pair
#define endl '\n'
using namespace std;
typedef unsigned long long ULL;
typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
const int inf = 0x3f3f3f3f;
const ll INF = 0x3f3f3f3f3f3f3f3f;
const int mod = 1e9 + 7;
const double eps = 1e-9;
const int N = 1e6 + 10, M = 4e5 + 10;

int n, k;

void solve()
{
    cin >> n >> k;
    string s;
    cin >> s;
    s = " " + s;
    int ans = 0;
    for (int i = 1; i <= n; ++i)
        if (s[i] == '1')
            ans++;
    int maxx = -INF;
    for (int i = 1; i <= k; ++i)
    {
        int cnt = 0;
        for (int j = i; j <= n; j += k)
        {
            if (s[j] == '1')
                cnt++;
            else
                cnt--;
            if (cnt < 0)
                cnt = 0;
            maxx = max(cnt, maxx);
        }
    }
    cout << ans - maxx << endl;
}
signed main(void)
{
    Zeoy;
    int T = 1;
    cin >> T;
    while (T--)
    {
        solve();
    }
    return 0;
}

标签:std,cnt,const,int,Codeforces,cin,变为,642,Div3
From: https://www.cnblogs.com/Zeoy-kkk/p/17291311.html

相关文章

  • codeforces 1795E Explosions?
    https://codeforces.com/problemset/problem/1795/E解题思路问题的核心是要构造有一个先严格递增,然后严格递减的子序列。不在这个序列中的怪物单独击杀。先递增后递减可以看作是两个对称的问题,所以把递增序列的构造考虑清楚就可以了。假设已经知道将1~i-1构造成严格递增子序列所......
  • Codeforces Round 862 (Div. 2)
    CodeforcesRound862(Div.2)链接CodeforcesRound862(Div.2)A题#include<iostream>#include<algorithm>#include<cstdio>#include<cstring>#include<vector>#include<cstring>#include<unordered_set>#includ......
  • Codeforces Round 863 (Div. 3)
    CodeforcesRound863(Div.3)链接CodeforcesRound863(Div.3)A题遍历这个字符串,如果要插入的数第一次小于当前的数,就将数插入到这里,如果到最后都没有插入数,插入到最后#include<iostream>#include<algorithm>#include<cstdio>#include<cstring>#include<vec......
  • Codeforces Round 863 (Div. 3) E题
    题目地址题意:定义数组a包含所有不含数字4的正整数,给出一个n,要求求出数组a中第n个数Solution数位dp+二分,求出[1,mid]中不含数字4的正整数个数,不过因为有可能mid包含4,但是由于贡献是一样的,可以直接把4都变成3,最后处理一下即可intdp[20];inta[20];voidinit(){ dp[0]=1; f......
  • Codeforces Round 863 (Div. 3)
    A.InsertDigit放在第一个比他小的数前面#include<bits/stdc++.h>usingnamespacestd;voidsolve(){intn,d;cin>>n>>d;strings;cin>>s;for(chari:s){if(d>i-'0')cout<<d,d......
  • Codeforces Round 640 (Div. 4) ABCDEFG
    https://codeforces.com/contest/1352不知道怎么的复制过来的代码容易歪,观看效果可能不大好。这场古早div4,大题极其友好,除了E卡空间卡到我爆炸,别的都体验感极好。A.SumofRoundNumbers#include<bits/stdc++.h>usingnamespacestd;typedeflonglongLL;typedefpai......
  • Codeforces Round 863 (Div. 3) A-C 赛后思路复盘
    A(思维)思路:观察样例可知数越大放在前面越优。遍历字符串,判断当前位置的数字和要插入的数字的关系,如果要插入的数大于当前数,那么就插入到当前数的前面。string里有一个insert函数,可以把指定字符串插入到指定下标之前。在原串下标为pos的字符前插入字符串strbasic_string&insert......
  • codeforces round 862
    A.和洛谷上的删数思路一致,后者是找峰顶,这个是找谷底从前到后枚举每一位与要添加的数比大小,如果要添加的数<=该位的数,就继续枚举,否则就将这个数添加在其前面B.需要移动的步数=两个点所在的层数之差的绝对值,只要计算出所在层数就可以一开始没想明白怎么算这个层数,先把每个......
  • Codeforces Round 861 (Div. 2)
    Preface这场感觉都是一个礼拜前补题打的了,但由于上周末事情比较多都没来得及写题解因此可能题意都记得不是很清楚了,就简略地谈一谈吧A.LuckyNumbers不难想到直接暴力从左端点枚举到右端点并对每个数进行暴力判断一个很naive的结论就是当答案为\(9\)时直接输出即可,然后我们......
  • Codeforces Round 862 A-E
    CodeforcesRound862(Div.2)先简单写一下A-E的题解。A异或的经典性质:\(x\oplusx=0\)。B显然要把字典序最小的那个字母放到最前面。如果这个字母出现了很多次,那么应该选择最后一次出现的位置。这也很容易证明。C联立以后计算一下就行了。比赛的时候爆了一次int。......